\\ Copyright 2017, 2018 Kevin Ryde
\\
\\ This file is free software; you can redistribute it and/or modify it
\\ under the terms of the GNU General Public License as published by the Free
\\ Software Foundation; either version 3, or (at your option) any later
\\ version.
\\
\\ This file is distributed in the hope that it will be useful, but
\\ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
\\ or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
\\ for more details.
\\
\\ You should have received a copy of the GNU General Public License along
\\ with this file  See the file COPYING.  If not, see
\\ <http://www.gnu.org/licenses/>.

default(recover,0)
\\ default(parisizemax,300*10^6);
read("memoize.gp");
read("../vpar.gp");
read("../vpar-wip.gp");
read("../test-helpers.gp");


\\------------------------------------------------------------------------------
\\ vpar_count_min_ancestor_increasing() formula with forest=-1
\\
\\ attach subtree under n-t-1 places, not all n-t
\\
\\ trees num_children[root]==1 and min ancestor increasing, same max increasing
\\ not in OEIS: 0, 2, 5, 24, 168, 1556, 18150,
\\
\\ root=1 trees num_children[root]==1 and min ancestor increasing, same max increasing
\\ not in OEIS: 0, 1, 2, 8, 47, 365, 3570,


{
  my(func=max,
     forest=1);
  for(n=1,7,
     my(count=0);
     forvec(vec=vpar_forvec_from(n,forest),
           my(vpar=vpar_from_upascend(vec),
              ancestors =vpar_minmax_ancestors_vector(vpar,func));
           \\ count += (test_vector_is_increasing(ancestors)
           \\           && vpar_num_children_of_vertex(vpar,vpar_root(vpar))==1);

           my(is_triple=1);
           for(v=1,#vpar,
              my(p=vpar[v]); p||next();
              my(g=vpar[p]); g||next();
              if(! (ancestors[v]==ancestors[p] || ancestors[p]==ancestors[g]),
                 is_triple=0;break()));
           count += is_triple;
     );
     print(count",");
  );
  quit;
}


\\------------------------------------------------------------------------------
\\ max ancestor is non-decreasing -- count formula

{ my(count=0); forvec(vec=vpar_forvec_from(5),count++); count }
check_exact(625, 5^4);

a(n) = 
{
  if(n==0,1, n==1,1,
     n^(n-2) + sum(p=1,n-1, a(p) * p * (n-p)^(n-p-2)));
}

f(n) = 
{
  my(debug=0);
  if(debug,print("n="n));
  my(t=0);
  if(n==0,t=1,
     n==1,t=1,

     if(debug,print(" "n"^",n-2," = ",n^(n-2)));  \\ n as root
     t=n^(n-2)  
     + sum(p=1,n-1,
             my(o=n-p);  \\ n-1 to 1
             if(debug,print(" p="p" o="o"  "o"^",o-2," * "p" * "f(p)));
             f(p) * p * o^(o-2)));
  if(debug,print(" total "t));
  t;
}
f=memoize(f);
a=memoize(a);
print("f ", vector(10,n,n--; f(n)));
print("a ", vector(25,n,n--; a(n)));
quit

\\ n=3
\\ [0, 1, 1]   vec [1, 2, 3]
\\ [0, 1, 2]   vec [1, 2, 3]
\\ [0, 3, 1]   vec [1, 3, 3]
\\ [2, 0, 1]   vec [2, 2, 3]
\\ [2, 0, 2]   vec [2, 2, 3]
\\ [3, 1, 0]   vec [3, 3, 3]
\\ [2, 3, 0]   vec [3, 3, 3]
\\ [3, 3, 0]   vec [3, 3, 3]
\\ count 8

\\------------------------------------------------------------------------------
\\ max ancestor is non-decreasing -- samples

{
  my(func=max);
  for(n=3,3,
     print("n="n);
     my(count=0);

     \\ for(i=1,100, my(vpar=vpar_make_random(n)); \\ trees

     forvec(vec=vpar_forvec_from(n),my(vpar=vpar_from_upascend(vec));
        my(vec =vpar_minmax_ancestors_vector(vpar,func));
        if(test_vector_is_increasing(vec),
           print(Vec(vpar)"   vec "vec);
           vpar_view(vpar,1);
           count++));
     print("count "count);
     print(););
  quit;
}


\\------------------------------------------------------------------------------
\\ max ancestor is non-decreasing -- count
\\ vpar_count_min_ancestor_increasing()

\\ not in OEIS: 1, 2, 8, 47, 365, 3570, 42796

{
  my(func=max);
  for(n=1,7,
     my(count=0);
     forvec(vec=vpar_forvec_from(n), \\ trees
           my(vpar=vpar_from_upascend(vec));
           my(anc =vpar_minmax_ancestors_vector(vpar,func));
           if(test_vector_is_increasing(anc),
              count++));
     print(count","););
  quit;
}


\\------------------------------------------------------------------------------
