\\ Copyright 2017, 2018 Kevin Ryde
\\
\\ This file is free software; you can redistribute it and/or modify it
\\ under the terms of the GNU General Public License as published by the Free
\\ Software Foundation; either version 3, or (at your option) any later
\\ version.
\\
\\ This file is distributed in the hope that it will be useful, but
\\ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
\\ or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
\\ for more details.
\\
\\ You should have received a copy of the GNU General Public License along
\\ with this file  See the file COPYING.  If not, see
\\ <http://www.gnu.org/licenses/>.

default(recover,0)
default(strictargs,1)
\\ default(parisizemax,300*10^6);
read("memoize.gp");
read("../vpar.gp");
read("../vpar-wip.gp");
read("../test-helpers.gp");

option_verbose=1;

vector_is_nondecreasing(v) = \
  for(i=2,#v, if(v[i]<v[i-1], return(0))); 1;
vector_is_nonincreasing(v) = \
  for(i=2,#v, if(v[i]>v[i-1], return(0))); 1;
vector_is_monotonic(v) = \
  vector_is_nonincreasing(v) || vector_is_nondecreasing(v);


\\------------------------------------------------------------------------------
\\ vpar_count_min_descendant_increasing() formula for root=1

C(n,forest) = if(n==0,1, (n-1)! + sum(t=1,n-1, C(n-t,forest)*(n-t+forest)*(t-1)!));

my(forest=-1, t=n-1); check_equal(n-t+forest,  0);
my(forest=-1, t=1);   check_equal(n-t+forest,  'n-2);
my(forest=-1, n=2);   check_equal((n-1)!,  1);
my(forest=-1, n=2);   check_equal(sum(t=1,1, C(1,-1)*(1-1)*(1-1)!),  0);
check_equal(C(3,-1),  3);
my(forest=-1, n=3);   check_equal((n-1)!,  2);
my(forest=-1, n=3);   check_equal(sum(t=1,2, C(n-t,-1)*(n-t-1)*(t-1)!),  1);
check_equal(C(1,1), 1);  \\ F(1)
check_equal(C(2,1), 3);  \\ F(3)
check_equal(C(2,0), 2);  \\ T(2)

P(n,forest) =
{
  print(n-1"!");
  my(name=if(forest==1,"F",forest==-1,"B","T"));
  for(t=1,n-1, print("+ "name"("n-t") * ("n-t+forest")* "t-1"!"));
}
P(5,0)
\\ 4!
\\ + T(4) * (4)* 0!
\\ + T(3) * (3)* 1!
\\ + T(2) * (2)* 2!        T(2)=2
\\ + T(1) * (1)* 3!        T(1)=1

P(5,1)
\\ 4!
\\ + F(4) * (5)* 0!
\\ + F(3) * (4)* 1!
\\ + F(2) * (3)* 2!
\\ + F(1) * (2)* 3!        F(1)=1

P(5,-1)
\\ 4!
\\ + B(4) * (3)* 0!         F(3)
\\ + B(3) * (2)* 1!         F(2)=3
\\ + B(2) * (1)* 2!         F(1)=1
\\ + B(1) * (0)* 3!         F(0)=1

\\ root=1
\\ whole run of 2s is 1 at top, 2 at bottom, (n-2)! between

\\ root=1
\\ k=1 to n-2 vertices
\\ put under n-k places
\\ t=k+1
\\ t=2 to n-1
\\ put under n-(t-1) = n-t+1 places

\\ F(n) = if(n==0,1, (n-1)! + sum(t=1,n-1, F(n-t)*(n-t+1)*(t-1)!))
\\ B(n) = if(n==0,1, (n-1)! + sum(t=1,n-1, B(n-t)*(n-t-1)*(t-1)!))
\\ B(n) = F(n-1)
\\      = if(n==0,1, (n-2)! + sum(t=1,n-2, F(n-t-1)*(n-t)*(t-1)!))
\\      = if(n==0,1, (n-2)! + sum(t=1,n-2, B(n-t)*(n-t)*(t-1)!))
\\      = if(n==0,1, (n-1)! - (n-1)! + (n-2)! + sum(t=1,n-2, B(n-t)*(n-t)*(t-1)!))
\\      = if(n==0,1, (n-1)! + (- (n-1) + 1)*(n-2)! + sum(t=1,n-2, B(n-t)*(n-t)*(t-1)!))
\\      = if(n==0,1, (n-1)! - (n+2)*(n-2)! + sum(t=1,n-2, B(n-t)*(n-t)*(t-1)!))
\\      = if(n==0,1, (n-1)! + sum(t=1,n-2, B(n-t)*(n-t-1)*(t-1)!)
\\                   - n*(n-2)! + sum(t=1,n-2, B(n-t)*(t-1)!))
B(n)=C(n,-1);
B(n)=if(n==0,1, (n-1)! + sum(t=1,n-1, B(n-t)*(n-t-1)*(t-1)!));
check_equal(vector(10,n, B(n)), vector(10,n, C(n,-1)));
vector(10,n,n++; -(n-1)! + (n-2)! + sum(t=1,n-2, B(n-t)*(t-1)!))
vector(10,n,n++; (-(n-1)+1)* (n-2)! + sum(t=1,n-2, B(n-t)*(t-1)!))
vector(10,n,n++; (-n+2)* (n-2)! + sum(t=1,n-2, B(n-t)*(t-1)!))
vector(10,n,n++; -(n-2)* (n-2)! + sum(t=1,n-2, B(n-t)*(t-1)!))

check_equal(vector(10,n,n++; (n-2)*(n-2)! ), \
            vector(10,n,n++; sum(t=1,n-2, B(n-t)*(t-1)!) ));
check_equal(vector(10,n,n++; (n-2)*(n-2)! + (n-2)! ), \
            vector(10,n,n++; sum(t=1,n-1, B(n-t)*(t-1)!) ));
check_equal(vector(10,n,n++; (n-1)*(n-2)! ), \
            vector(10,n,n++; sum(t=1,n-1, B(n-t)*(t-1)!) ));
check_equal(vector(10,n,n++; (n-1)! ), \
            vector(10,n,n++; sum(t=1,n-1, B(n-t)*(t-1)!) ));


\\------------------------------------------------------------------------------
\\ vpar_minmax_descendants_vector() min increasing with root=1

{
  my(forest=-1);
  for(n=1,4,
     my(count=0);
     forvec(vec=vpar_forvec_from(n,forest),
           my(vpar=vpar_from_upascend(vec),
              min_descendants=vpar_minmax_descendants_vector(vpar,min),
              is_min_increasing=test_vector_is_increasing(min_descendants));
           count += is_min_increasing;
           if(is_min_increasing,
              print(min_descendants"   "vpar" h="vpar_height(vpar));
           ));
     print(count"    "n-1"! = "if(n>=1,(n-1)!));
  );
  quit;
}


\\------------------------------------------------------------------------------
\\ min and max descendant both increasing

\\     4           [2, 3, 4, 0, 2]
\\     |
\\     3          min [1, 1, 1, 1, 5]
\\     |          max [1, 5, 5, 5, 5]
\\     2
\\    / \         degrees [1, 3, 2, 1, 1]
\\   1   5
{
  for(n=7,7,
     my(m=Map());
     forvec(vec=vpar_forvec_from(n,0), \\ trees or forests
           my(vpar=vpar_from_upascend(vec),
              min_descendants=vpar_minmax_descendants_vector(vpar,min),
              max_descendants=vpar_minmax_descendants_vector(vpar,max),
              key=[min_descendants,max_descendants]);           
           if(test_vector_is_increasing(min_descendants)
              && test_vector_is_increasing(max_descendants)
              && !mapisdefined(m,key),
              my(degrees=vpar_degrees_vector(vpar));
              mapput(m,key,1);
              printf("%-*s %s  %s\n", 3*n+3,vpar, min_descendants,
                     if(vecmax(degrees)>=4,degrees,""));
              printf("%-*s %s\n", 3*n+3,"", max_descendants);
              print();
             );
           ))
}
quit

\\------------------------------------------------------------------------------
\\ max descendant non-decreasing -- counts by height etc

\\ by height
\\ n=6  count [0, 2, 208, 476, 376, 235]
\\ not in OEIS: 208, 476, 376, 235
\\ n=7  count [0, 2, 845, 3074, 2978, 1927, 1237]
\\ not in OEIS: 845, 3074, 2978, 1927, 1237
\\ vecsum([0, 2, 845, 3074, 2978, 1927, 1237])

\\ by num leaf (childless)
\\ n=6  count [235, 523, 447, 90, 2, 0]
\\ n=7  count [1237, 2913, 3926, 1793, 192, 2, 0]
\\ not in OEIS: 235, 523, 447, 90
\\ not in OEIS: 1237, 2913, 3926, 1793, 192
\\ not in OEIS: 90, 447, 523, 235
\\ not in OEIS: 192, 1793, 3926, 2913, 1237


{
  my(func=max);
  for(n=1,7,
     my(count=vector(n));
     forvec(vec=vpar_forvec_from(n,0), \\ trees or forests
           my(vpar=vpar_from_upascend(vec),
              desc =vpar_minmax_descendants_vector(vpar,func),
              \\ h=vpar_height(vpar)+1
              h=vpar_num_childless(vpar)
             );
           if(test_vector_is_increasing(desc),
              count[h]++));
     print("n="n"  count "count));
}
quit;


\\------------------------------------------------------------------------------
\\ max descendant non-decreasing -- count

{
  my(func=max);
  for(n=0,7,
     my(count=0);
     forvec(vec=vpar_forvec_from(n), \\ trees
           my(vpar=vpar_from_upascend(vec));
           my(desc =vpar_minmax_descendants_vector(vpar,func));
           \\ for(i=1,#desc, if(desc[i]==i,desc[i]=0));
           if(vector_is_monotonic(desc),
              count++));
     print("n="n"  count "count));
}
quit;


\\------------------------------------------------------------------------------

indec(n) = if(n==0,0, n! - sum(k=1,n-1, k!*indec(n-k)));
check_equal(vector(10,n,n--; indec(n)), [0,1,1,3,13,71,461,3447,29093,273343]);

\\ T(n,n-d) = (n-d)*T(n,n-(d-1)) + sum(j=0,n-(n-d)-1), T(j,0)*T(n,j+n-d+1))
\\          = (n-d)*T(n,n-(d-1)) + sum(j=0,d-1, T(j,0)*T(n,n-(d-1-j)))

T0 =                                                                       1;
T1 =                                                                n +    0;
T2 =                                                     n^2 -      n +    1;
T3 =                                          n^3 -    3*n^2 +    4*n +    1;
T4 =                               n^4 -    6*n^3 +   14*n^2 -    9*n +   11;
T5 =                     n^5 -  10*n^4 +   39*n^3 -   65*n^2 +   61*n +   31;
T6 =           n^6 -  15*n^5 +  90*n^4 -  263*n^3 +  404*n^2 -  213*n +  333;
T7 =  n^7 - 21*n^6 + 181*n^5 - 810*n^4 + 2016*n^3 - 2628*n^2 + 2087*n + 1597;

check_equal((n-1)*T0 + indec(1)*T0, T1);
check_equal((n-2)*T1 + indec(1)*T1 + indec(2)*T0, T2);
check_equal((n-3)*T2 + indec(1)*T2 + indec(2)*T1 + indec(3)*T0, T3);
check_equal((n-4)*T3 + indec(1)*T3 + indec(2)*T2 + indec(3)*T1 + indec(4)*T0, T4);

'n
T0 = i1
T1 = (n-1)*T0 + i1*T0
T2 = (n-2)*T1 + i1*T1 + i2*T0
T3 = (n-3)*T2 + i1*T2 + i2*T1 + i3*T0

quit


\\------------------------------------------------------------------------------
\\ A104980 matrix

\\ column 0 = A003319 indecomposable permutations
\\ column 1 = A104981  = column 1 of A156628
\\ column 2 = A003319 (shifted down one)

\\ exponential e^m = sum(i=0,inf, m^i / i! ) = I + m + m^2/2 + ...

\\ k=  0    1   2   3   4   5
\\     1;
\\     1,   1;
\\     3,   2,  1;
\\    13,   7,  3,  1;
\\    71,  33, 13,  4,  1;
\\   461, 191, 71, 21,  5,  1;

\\ Paul D. Hanna in A104980
A104980(n,k) =
{
  if(n<k||k<0, 0,
     n==k, 1,
     n==k+1, n,
     k*A104980(n, k+1) + sum(j=0,n-k-1, A104980(j, 0)*A104980(n, j+k+1)));
}

for(n=0,9, for(k=0,n, printf("%8d ",A104980(n,k))); print());

\\ k=1
\\ if(n<1, 0,
\\    n==1, 1,
\\    n==2, n,
\\    A104980(n, 2) + sum(j=0,n-2, A104980(j, 0)*A104980(n, j+2)));

\\    A104980(n, 2) + sum(j=1,n-1, A104980(j-1, 0)*A104980(n, j+1)));

\\ A156628 
\\ row n+1 = row n delete all (m+1)*(m+2)/2-2 for m>0 then partial sums
\\ row 0     1, 1, 1, 1, 1, 1,

\\ diagonal 0 = integers n
check_equal(vector(150,n,n--; A104980(n,n)), \
            vector(150,n,n--; 1))

\\ diagonal -1 = integers n
check_equal(vector(150,n,n--; A104980(n,n-1)), \
            vector(150,n,n--; n))

\\ diagonal -2 = n^2 - n + 1
\\ A002061 central polygonal
check_equal(vector(150,n,n++; A104980(n,n-2)), \
            vector(150,n,n++; n^2 - n + 1))

\\ diagonal -3 = n^3 - 3*n^2 + 4*n + 1
\\ not in OEIS: 13, 33, 71, 133, 225, 353, 523, 741, 1013
\\ irreducible
\\ not in OEIS: -0.213411662762229634132131   \\ real root
\\ not in OEIS: 1.60670583138111481706606
\\ not in OEIS: -1.45061224918844152651544
check_equal(vector(150,n,n+=2; A104980(n,n-3)), \
            vector(150,n,n+=2; n^3 - 3*n^2 + 4*n + 1))

\\ diagonal -4 = n^4 - 6*n^3 + 14*n^2 - 9*n + 11
\\ not in OEIS: 71, 191, 461, 977, 1859, 3251, 5321, 8261, 12287
\\ irreducible
check_equal(vector(150,n,n+=3; A104980(n,n-4)), \
            vector(150,n,n+=3; n^4 - 6*n^3 + 14*n^2 - 9*n + 11))

\\ diagonal -5 = n^5 - 10*n^4 + 39*n^3 - 65*n^2 + 61*n + 31
\\ irreducible
check_equal(vector(150,n,n+=4; A104980(n,n-5)), \
            vector(150,n,n+=4; n^5 - 10*n^4 + 39*n^3 - 65*n^2 + 61*n + 31))

\\ diagonal -6 = n^6 - 15*n^5 + 90*n^4 - 263*n^3 + 404*n^2 - 213*n + 333
check_equal(vector(150,n,n+=5; A104980(n,n-6)), \
  vector(150,n,n+=5; n^6 - 15*n^5 + 90*n^4 - 263*n^3 + 404*n^2 - 213*n + 333))

\\ diagonal -7
\\   = n^7 - 21*n^6 + 181*n^5 - 810*n^4 + 2016*n^3 - 2628*n^2 + 2087*n + 1597
check_equal(vector(150,n,n+=6; A104980(n,n-7)), \
            vector(150,n,n+=6; \
  n^7 - 21*n^6 + 181*n^5 - 810*n^4 + 2016*n^3 - 2628*n^2 + 2087*n + 1597))

\\recurrence_guess(vector(50,n,n--; A104980(n,n-7)))

\\                                                                       1
\\                                                                n +    0
\\                                                     n^2 -      n +    1
\\                                          n^3 -    3*n^2 +    4*n +    1
\\                               n^4 -    6*n^3 +   14*n^2 -    9*n +   11
\\                     n^5 -  10*n^4 +   39*n^3 -   65*n^2 +   61*n +   31
\\           n^6 -  15*n^5 +  90*n^4 -  263*n^3 +  404*n^2 -  213*n +  333
\\  n^7 - 21*n^6 + 181*n^5 - 810*n^4 + 2016*n^3 - 2628*n^2 + 2087*n + 1597

\\ not in OEIS: 11, 31, 333, 1597
\\ not in OEIS: 4, 9, 61, 213, 2087
\\ not in OEIS: 3, 14, 65, 404, 2628

\\ first coeffs constant 1
\\ second coeffs triangular 3, 6, 10, 15, 21
\\ not in OEIS: 4, 14, 39, 90, 181
\\ not in OEIS: 9, 65, 263, 810


{
  check_equal(
                                                                      1
   +                                                           n +    0
   +                                                n^2 -      n +    1
   +                                     n^3 -    3*n^2 +    4*n +    1,
              n^3 - 2*n^2 + 4*n + 3);
}
my(n=4); check_equal(n^3 - 2*n^2 + 4*n + 3, 51);

{
  check_equal(
                                                                      1
   +                                                           n +    0
   +                                                n^2 -      n +    1
   +                                     n^3 -    3*n^2 +    4*n +    1
   +                           n^4 -    6*n^3 +   14*n^2 -    9*n +   11,
              n^4 - 5*n^3 + 12*n^2 - 5*n + 14);
}
my(n=5); check_equal(n^4 - 5*n^3 + 12*n^2 - 5*n + 14, 289);


my(n=8); check_equal(n^7 - 21*n^6 + 181*n^5 - 810*n^4 + 2016*n^3 - 2628*n^2 + 2087*n + 1597, \
                     87669);

quit;


\\------------------------------------------------------------------------------
\\ A104980 matrix powers

\\ SHIFT_LEFT(column 0 of T^p) = p*(column p+1 of T)
\\ [T^p](m,0) = p*T(p+m,p+1)  for all m>=1 and p>=-1

\\ T(n,k) = k*T(n, k+1) + sum(j=0,n-k-1, T(j,0) * T(n, j+k+1))     for n>k>0
\\                                      indec(j)      k+1 to n
\\ with
\\   T(n,n) = 1
\\   T(n+1, n) = n+1
\\   T(n+1, 2) = T(n, 0) for n>=0

\\ T(j,0) = indecomposables A003319
\\ gf 1 - 1/(sum k!*x^k) 
\\ a(n)   = n! - sum(k=1,n-1, k!*a(n-k))
\\ a(n+1) = (n+1)!   - sum(k=1,n,       k!*a(n+1-k))
\\        = (n+1)*n! - sum(k=1,n, k*(k-1)!*a(n-(k-1)))

\\         indec(n-1)
\\ T(n,1) =  T(n,2) + sum(j=0,n-2, indec(j) * T(n, 2+j))
\\
\\ seeking a(n) = if(n==0,0, (n-1)! + sum(p=1,n-1, a(p) * p * (n-1-p)!));

{
T = [1,   0,   0,  0,  0,  0, 0;
     1,   1,   0,  0,  0,  0, 0;
     3,   2,   1,  0,  0,  0, 0;
     13,  7,   3,  1,  0,  0, 0;
     71,  33,  13, 4,  1,  0, 0;
     461, 191, 71, 21, 5,  1, 0;
     3447,1297,461,133,31, 6, 1 ];
}
s=matsize(T)[1];
T
{
  for(p=-1,s-1,
     for(m=0,s-1,
        printf(" %6s", 
               if(m+1>=1 && m+1<=s, (T^p)[m+1,1], ".")));
     print());
}
print();
{
  for(p=-1,s,
     for(m=0,s,
        printf(" %6s", 
               if(p+m+1>=1 && p+m+1<=s && p+1+1>=1 && p+1+1<=s,
                  p * T[p+m+1,p+1+1],
                  ".") ));
     print());
}

T^-1
quit


\\------------------------------------------------------------------------------
\\ transformation

transform(f,n) = if(n==0,0,  f(n) + sum(p=1,n-1, transform(f,p)*p*f(n-p)));
transform=memoize(transform);

a(n) = if(n==0,0, (n-1)! + sum(p=1,n-1, a(p) * p * (n-1-p)!));
a=memoize(a);

check_equal(vector(20,n,a(n)), vector(20,n,transform(n->(n-1)!, n)));
vector(10,n,transform(n->n^(n-2), n))
vector(10,n,n--;transform(n->3, n))

transform_by_compositions(f,n) =
{
  if(n==0,return(0));
  my(total=0, v=test_compositions(n));
  sum(i=1,#v,
     my(c=v[i]);
     prod(i=1,#c, f(c[i]))
     * prod(i=2,#c, vecsum(c[1..i-1])));
}
check_equal(vector(10,n,a(n)), \
            vector(10,n,transform_by_compositions(n->(n-1)!, n)));
check_equal(vector(10,n,transform(                n->(n-1)!, n)), \
            vector(10,n,transform_by_compositions(n->(n-1)!, n)));
check_equal(vector(10,n,transform(                n->n^(n-2), n)), \
            vector(10,n,transform_by_compositions(n->n^(n-2), n)));

quit

\\------------------------------------------------------------------------------

A104981_by_compositions(n) =
{
  if(n==0,return(0));
  my(total=0, v=test_compositions(n));
  sum(i=1,#v,
     my(c=v[i]);
     prod(i=1,#c, (c[i]-1)!)
     * prod(i=2,#c, vecsum(c[1..i-1])));
}
\\ A104981_samples=[0,1,2,7,33,191,1297,10063,87669,847015,8989301,103996703];
vector(#A104981_samples,n,n--; A104981_by_compositions(n)) == A104981_samples

f(n) =
{
  if(n==0,return(0));
  my(total=0, v=test_compositions(n));
  sum(i=1,#v,
     my(c=v[i]);
     prod(i=2,#c, vecsum(c[1..i-1])));
}
vector(10,n,n--; f(n))
\\ factorials
\\ 0, 1, 2, 6, 24, 120, 720, 5040, 40320, 362880


n=7;
m=Map();
v=test_compositions(n);
{
  for(i=1,#v,
     my(c=v[i],
        s=prod(i=2,#c, vecsum(c[1..i-1])),
        k=vecsort(c),
        l=if(mapisdefined(m,k),mapget(m,k),List([])));
     listput(l,s);
     mapput(m,k,l));
}
m=Mat(m);
{
  for(i=1,matsize(m)[1],
     my(k=m[i,1],
        v=Vec(m[i,2]));
     print(k,"  ",vecsum(v),"  ",v));
}
vecsum(concat(Vec(apply(Vec,m[,2]))))
quit;

\\ [1,1,1,4] etc factors
\\ 7,38,168,600,1764

\\------------------------------------------------------------------------------
\\ growth

a(n) = if(n==0,0, (n-1)! + sum(p=1,n-1, a(p) * p * (n-1-p)!));
a=memoize(a);
ploth(n=1,500, my(n=floor(n)); log(a(n)) );
for(n=1,100,print(my(n=2^n); log(a(n))y));
\\ for(n=1,100, my(n=2^n); print(a(n)/n! /n *1.0));
quit


\\------------------------------------------------------------------------------

v=[t1,t2,t3,t4];
{
  sum(i=1,(#v)!,
        my(perm=numtoperm(#v,i));
        prod(i=1,#v-1, sum(j=1,i, v[perm[j]])))
  ==
  0
  + 6* t1^3
  + 6*        t2^3
  + 6*               t3^3
  + 6*                      t4^3

  + 6* t1   * t2   * t3
  + 6* t1   * t2          * t4
  + 6* t1          * t3   * t4
  + 6*        t2   * t3   * t4

  + 8* t1^2 * t2
  + 8* t1^2        * t3
  + 8* t1^2               * t4
  + 8* t1   * t2^2
  + 8* t1          * t3^2
  + 8* t1                 * t4^2
  + 8*        t2^2 * t3
  + 8*        t2^2        * t4
  + 8*        t2  * t3^2
  + 8*        t2          * t4^2
  + 8*              t3^2  * t4
  + 8*              t3    * t4^2
}
quit


\\------------------------------------------------------------------------------
\\ seq max descendant is identity -- func
\\ A104981

a(n) = if(n==0,0, (n-1)! + sum(p=1,n-1, a(p) * p * (n-1-p)!));

f(n) =
{
  my(debug=0);
  if(debug,print("n="n));
  my(t);
  if(n==0, t=0,
     n==1, t=1,
     if(debug,print(" ",n-1,"! = ",(n-1)!));
     t=0 
       + (n-1)!
       + sum(p=1,n-1,
               if(debug,print(" ",n-p-1,"! * "p" * "f(p)" = ",p*(n-p-1)!*f(p)));
               f(p) * p * (n-p-1)!));
  if(debug,print(" = "t));
  t;
}
f=memoize(f);
vector(7,n,n--; f(n))

\\ A104981_samples=[0,1,2,7,33,191,1297,10063,87669,847015,8989301,103996703,1303132269,17589153719,254509227541,3931158238735,64573130459613,1124144767682215,20677664894412965,400760695386194687,8163539437728923181];
print("f ",vector(#A104981_samples,n,n--; f(n)));
print("A104981_samples ",A104981_samples);
vector(#A104981_samples,n,n--; f(n)) == A104981_samples
vector(#A104981_samples,n,n--; a(n)) == A104981_samples
quit


\\------------------------------------------------------------------------------
\\ A128175 matrix
\\ = A007318 * A128174
\\   Pascal triangle * (1,0,1 matrix)
\\ then A104981 = sum row n of (A128175 triangle except initial 1)^(n-1)

\\  1;
\\  1,  1;
\\  2,  2,  1;
\\  4,  4,  3,  1;
\\  8,  8,  7,  4,  1;
\\ 16, 16, 15, 11,  5,  1;
\\ 32, 32, 31, 26, 16,  6, 1;
\\ 64, 64, 63, 57, 42, 22, 7, 1;


\\------------------------------------------------------------------------------
\\ seq max descendant is identity
\\ max_descendant is non-decreasing with v
\\ 1, 2, 7, 33, 191, 1297

\\ maxdec(n) = n
\\ so path n up to root must be n-d,...,n final vertices all maxdec(n)=n,
\\ in some order.
\\ Next highest m=n-d-1 path up to the n'smust be m-e,...,m some order.

{
  \\ 
  for(n=1,8,
     my(total=0);
     forvec(v=vector(n,i,if(i==1,[1,1],[0,1])),
           my(this=1,f=1);
           for(i=1,#v,
              if(v[i]==0,
                 this*=i-1; f=1,
                 this*=f; f++));
           total += this);
     print("  "total));
  quit;
}
{
  \\ A107107 sum partitions prod((a[i]-1)!)
  for(n=1,8,
     my(total=0);
     forpart(v=n,
             total+=prod(i=1,#v, (v[i]-1)!));
     print("  "total));
  quit;
}

{
  my(func=max);
  for(n=7,7,
     print("n="n);
     my(idseq=vpar_INTERNAL_identity_perm(n),
        count=0);
     forvec(vec=vpar_forvec_from(n), \\ trees
           my(vpar=vpar_make_random(n));
           \\ vpar=vpar_reroot(vpar,7);
           my(seq =vpar_seq_minmax_descendant(vpar,func));
           my(vec =vpar_minmax_descendants_vector(vpar,func));
           if(seq == idseq,
              print(Vec(vpar)"  seq "Vec(seq)"  desc "vec);
              vpar_view(vpar,1);
              count++));
     print("count "count);
     print(););
  quit;
}

\\------------------------------------------------------------------------------
