\\ Copyright 2017, 2018 Kevin Ryde
\\
\\ This file is free software; you can redistribute it and/or modify it
\\ under the terms of the GNU General Public License as published by the Free
\\ Software Foundation; either version 3, or (at your option) any later
\\ version.
\\
\\ This file is distributed in the hope that it will be useful, but
\\ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
\\ or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
\\ for more details.
\\
\\ You should have received a copy of the GNU General Public License along
\\ with this file  See the file COPYING.  If not, see
\\ <http://www.gnu.org/licenses/>.

default(recover,0)
\\default(parisizemax,300*10^6);
read("../vpar.gp");
read("../vpar-wip.gp");
setrand(getwalltime()%2^32);

check_count = 0;
check_exact(got,want,name="") =
{
  check_count++;
  if(got!= want,
     print("wrong: "name);
     print("got  "got);
     print("want "want);
     quit(1),
     option_verbose,
     print("ok "check_count" "name));
}


\\------------------------------------------------------------------------------
\\ vpar_num_children_vector() duplication

\\ trees root=1
\\ = forests
\\ uniques 1 3 10 35 126 462 1716
\\ A088218 total number of leaves
\\ = A001700 binomial(2n+1, n+1)
\\
\\ trees any root
\\ uniques 1 2 6 20 70 252 924
\\ maybe A000984 binomial(2*n,n)
\\
\\ forests, sort num_children vec = partitions of n  A000041
\\ 1 2 4 7 12 19 30 45

{
  my(forest=1);
  for(n=1,8,
     my(seen=Map());
     forvec(vec=vpar_forvec_from(n,forest),
           my(vpar=vpar_from_upascend(vec));
           
           my(vec=vpar_num_children_vector(vpar));
           vec=vecsort(vec);
           \\ print(vpar" vec="vec,if(mapisdefined(seen,vec)," duplicate",""));
           mapput(seen,vec,1);
     );
     seen=Mat(seen);
     print(matsize(seen)[1],",");
  );
}
quit

\\------------------------------------------------------------------------------
\\ sequence num children sorted

vector_smallest_not_occurring(vec) =
{
  my(seen=vectorsmall(#vec+2));
  for(i=1,#vec, seen[vec[i]+1]=1);
  for(i=1,#seen, if(!seen[i],return(i-1)));
  error();
}
vector_count_unseen(vec) =
{
  my(unseen=vector(#vec+2,i,1));
  for(i=1,#vec, unseen[vec[i]+1]=0);
  vecsum(unseen);
}

{
  my(n=5,
     l=List([]));
  forvec(vec=vpar_forvec_from(n,-1),
        my(vpar=vpar_from_upascend(vec));

        my(seq=vpar_seq_num_children(vpar),
           vec=vecextract(vpar,seq));
        listput(l,[vpar,seq,vec]));
  l=vecsort(l,(x,y)->lex(x[3],y[3]));
  
  for(i=1,#l,
    my(vpar=l[i][1],
       seq =l[i][2],
       vec =l[i][3],
       \\ su=vector_smallest_not_occurring(vec[1..#vec-1]),
       su=vector_count_unseen(vec[1..#vec-1]),
       cyc=if(vpar_is_cyclic(vec)," cyc",""));
     print("vpar=",vpar," seq=",Vec(seq),"  ",vec,"  ",su,cyc);
  );
}
quit

\\------------------------------------------------------------------------------
\\ vpar_seq_num_children() from

\\setrand(2);
vpar=vpar_make_random(10);
\\vpar_view(vpar);
print("vpar             ",vpar);
print("num children     ",vpar_num_children_vector(vpar));
print("total ",vecsum(vpar_num_children_vector(vpar)));
seq=vpar_seq_num_children(vpar);
print("seq              ",Vec(seq));
vec=vecextract(vpar,seq);
print("vec              ",vec);

print("vec num children ",vpar_num_children_vector(vec));
vpar_num_children_vector(vpar) == vpar_num_children_vector(vec)
seq_again=vpar_INTERNAL_seqfrom_num_children(vec);
print("seq again        ",Vec(seq_again));
seq==seq_again
quit


\\------------------------------------------------------------------------------
\\ sequence num children

{
  my(n=5,
    prev_vec=vector(n,i,-1));
  forvec(vec=vpar_forvec_from(n,0),
        my(vpar=vpar_from_upascend(vec));

        my(seq=vpar_seq_num_children(vpar),
           vec=vecextract(vpar,seq),
           \\ su=vector_smallest_not_occurring(vec[1..#vec-1]),
           su=vector_count_unseen(vec[1..#vec-1])
          );
        print("vpar=",vpar," seq=",Vec(seq),"  ",vec,"  ",su);
        if(lex(prev_vec,vec)>=0,
           print("  not increase"));
        prev_vec=vec;
  );
}
print();
{
  my(vecs=[ [2, 3, 1, 0],
           [2, 3, 0, 1],
           [2, 0, 3, 1],
           [0, 2, 3, 1] ]);
  for(i=1,#vecs,
     my(vec=vecs[i],
        vpar=vpar_from_upascend(vec));

     my(seq=vpar_seq_num_children(vpar),
        vec=vecextract(vpar,seq));
     print("vpar=",vpar," seq=",Vec(seq),"  ",vec));
}

\\ vpar=[3, 1, 0, 2] seq=[4, 1, 2, 3]  [2, 3, 1, 0]
\\ vpar=[2, 3, 0, 1] seq=[4, 1, 2, 3]  [1, 2, 3, 0]
\\ vpar=[0, 3, 1, 2] seq=[4, 1, 2, 3]  [2, 0, 3, 1]
\\ [0, 2, 3, 1] does not occur


quit


\\------------------------------------------------------------------------------
\\ vpar_from_num_children()

{
  my(n=5,
     seen=Map());
  forvec(vec=vpar_forvec_from(n,1),  \\ forests
        my(orig_vec=vec,
           vpar=vpar_from_upascend(vec),

           seq =vpar_seq_num_children(vpar),
           vec =vecextract(vpar,seq),
           seen_str=if(mapisdefined(seen,vec)," seen",""),

           vpar_again=vpar_from_num_children(vec),
           different_str=if(vpar==vpar_again,""," different"));
        print(orig_vec" vpar="vpar" seq="Vec(seq)
              "  vec="vec
              " vpar_again="vpar_again,seen_str,different_str);
  );
  quit
}

