\\ Copyright 2019 Kevin Ryde
\\
\\ This file is free software; you can redistribute it and/or modify it
\\ under the terms of the GNU General Public License as published by the Free
\\ Software Foundation; either version 3, or (at your option) any later
\\ version.
\\
\\ This file is distributed in the hope that it will be useful, but
\\ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
\\ or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
\\ for more details.
\\
\\ You should have received a copy of the GNU General Public License along
\\ with this file  See the file COPYING.  If not, see
\\ <http://www.gnu.org/licenses/>.

default(recover,0);
default(strictargs,1);
read("../vpar.gp");
read("../test-helpers.gp");




L_to_vpar(L) =
{
  my(vpar=vector(#L>>1),
     v=1,
     l=L[1],
     t=#vpar+1,
    );
  while(v<#vpar,
        if(bitand(l,1),
           l=vpar[t++];  \\ l odd, pop stack
           ,
           \\ l even, new vertex, descend to left, push right
           vpar[v]=
           vpar[t--] = L[l+1];  \\ push ontop stack
           
           l=L[l]))
           
  if(v%2, [],
     vpar_concat_forest(vpar_join([0],1, L_to_vpar(L,L[v])),
                                         L_to_vpar(L,L[v+1])));
}





random_decorated_L(0)
random_decorated_L(1)
random_decorated_L(2)

vpar_join([0],1, [])       == [0] || error();
vpar_concat_forest([0],[]) == [0] || error();
L_to_vpar(random_decorated_L(0))
L_to_vpar(random_decorated_L(1))
L_to_vpar(random_decorated_L(2))

test_random_decorated_L = \
  eval(test_random_to_test_random(random_decorated_L));
{
  for(n=0,5,
     my(limits=vector(2*n,i, if(i%2,i,2)));
     \\ print("n="n" limits "limits);
     my(m=Map());
     forvec(values=apply(l->[0,l-1], limits),
           \\ print(" values "values);
           test_random_limit_list=List(limits);
           test_random_list      =List(values);
           my(L=test_random_decorated_L(n));
           \\ print(L);
           my(vpar=L_to_vpar(L));
           \\ print("  "vpar);

           if(n==2,print(L));
           if(L==[4, 5,1, 2,3],
              print("found "limits" "values));

           my(count=0);
           mapisdefined(m,vpar,&count);
           mapput(m,vpar,count+1);
     );
     m=Mat(m);
     print(m);

     my(vpars=Vec(m[,1]));
     check_equal(vecsort(vpars),
                 Vecrev(vpar_preorder_all(n,1)));
     my(counts=Vec(m[,2]));
     check_equal(counts,
                 vector(#counts,i, (n+1)!));

     my(total=vecsum(counts));
     check_equal(total, vpar_count_ordered(n,1) * (n+1)!);
  );
}








\\ decorated binary tree n, each external has a label 1..n+1
\\ decorated n-1
\\ choose x = one of 2n-1 internal and external
\\ change x =>    internal          internal
\\                /     \            /   \
\\               n       x          x     n
\\            external                  external
\\
\\ L0 to L2n inclusive
\\ externals even, internals odd
\\ L0 = root
\\ internal node 2k-1 for 1 <= k <= n has left L[2k-1] right L[2k]
\\ k=1 left L[3] right L[4]
\\
\\      0  1  2
\\     [1, 2, 0]
\\
\\          1 int
\\         / \
\\    ext 2   0 ext
\\
\\      0  1  2  3  4  5  6
\\     [1, 3, 2, 4, 0]
\\
\\          1 int
\\         / \
\\    int 3   2 ext
\\       / \
\\  ext 4   0 ext

\\ setrand(getwalltime()%2^32);
random_decorated(n) =
{
  my(L=vector(2*n+1));
  for(n=1,n,
     print("n="n" random of "2*n-1" and 2");
     my(k=random(2*n-1),   \\ 0 to 2n inclusive before n increment
        b=random(2));      \\ bit
     print("  k="k" b="b" set to "2*n-b" "2*n-!b);
     L[2*n-b +1]  = 2*n;       \\ 1or2  child external 2n even
     L[2*n-!b +1] = L[k +1];   \\ 2or1  child down previous k
     L[k +1]      = 2*n-1);    \\ new internal replacing
  L;
}
random_decorated(0)
random_decorated(1)
random_decorated(2)

test_random_decorated = \
  eval(test_random_to_test_random(random_decorated));
{
  for(n=0,2,
     my(limits=vector(2*n,i, if(i%2,i,2)));
     print("n="n" limits "limits);
     forvec(values=apply(l->[0,l-1], limits),
           print(" values "values);
           test_random_limit_list=List(limits);
           test_random_list      =List(values);
           print(test_random_decorated(n))));
}
