\\ Copyright 2017, 2018 Kevin Ryde
\\
\\ This file is free software; you can redistribute it and/or modify it
\\ under the terms of the GNU General Public License as published by the Free
\\ Software Foundation; either version 3, or (at your option) any later
\\ version.
\\
\\ This file is distributed in the hope that it will be useful, but
\\ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
\\ or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
\\ for more details.
\\
\\ You should have received a copy of the GNU General Public License along
\\ with this file  See the file COPYING.  If not, see
\\ <http://www.gnu.org/licenses/>.

default(recover,0)
\\ default(parisizemax,300*10^6);
read("../vpar.gp");
read("../vpar-wip.gp");
read("memoize.gp");
setrand(getwalltime()%2^32);


check_count = 0;
check_exact(got,want,name="") =
{
  check_count++;
  if(got!= want,
     print("wrong: "name);
     print("got  "got);
     print("want "want);
     quit(1),
     option_verbose,
     print("ok "check_count" "name));
}


\\------------------------------------------------------------------------------
\\ vpar_subtree_sizes_vector() occurring count formula

\\        15
\\      /  \  \
\\     6    6   2
\\    / \  / \   \
\\   2  3  3  2   1
\\  /  /|  |  |
\\ 1  1 1  2  1
\\         |
\\         1
\\
\\ 1+3+5+6 == 15
\\ 6+6+2 == 14
\\
\\ take 2 x 6s = 12
\\ rest 14-12=2 and below it 2+3 + 3+2 + 2 = 12
\\ make [15]
\\ make [6,6,2]
\\ break into k many 4s, distinct partitions of rest
\\ sizes above must sum to, using below <=m

F(l,m) =
{
  \\ print("F "l" m "m);
  if(#l==0, return(1));
  my(m=l[1]);
  l=l[^#l];
  if(m==1, return(1));
  my(ret=0);
  forpart(p=m-1,
          ret += F(setunion(Vec(p),l)));
  ret;
}
F([2])
F([3])
F([4])
vector(10,n,F([n]))


\\------------------------------------------------------------------------------
\\ vpar_subtree_sizes_vector() occurring count formula

\\ WRONG
\\ not in OEIS: 1, 1, 2, 4, 9, 20, 49, 115, 287, 700
F(l) =
{
  \\ print("F "l);
  if(#l==0, return(1));
  my(m=l[#l]);
  l=l[^#l];
  if(m==1, return(1));
  my(ret=0);
  forpart(p=m-1,
          ret += F(setunion(Vec(p),l)));
  ret;
}
F([2])
F([3])
F([4])
vector(10,n,F([n]))
quit

\\------------------------------------------------------------------------------
\\ vpar_subtree_sizes_vector() occurring

\\ forests distinct subtree_sizes
\\ trees root=1 distinct subtree_sizes same but 1 later
\\ not in OEIS: 1, 3, 13, 79, 571, 5031, 50100,
\\
\\ trees distinct subtree_sizes
\\ not in OEIS: 1, 2, 9, 52, 395, 3426, 35217,

\\ forests distinct sorted subtree_sizes
\\ not in OEIS: 1, 1, 2, 4, 9, 19, 44, 96, 220,
\\ not A247623 = 1,1,2,4,9,19,44,96,225
\\ trees distinct sorted subtree_sizes same 1 later

{
  my(forest=1); \\ forests or trees
  for(n=1,9,
     my(count=0,
        m=Map());
     forvec(vec=vpar_forvec_from(n,forest),
           my(vpar=vpar_from_upascend(vec),
              subtree_sizes = vpar_subtree_sizes_vector(vpar));
           subtree_sizes=vecsort(subtree_sizes);
           mapput(m,subtree_sizes,1);

           \\ my(c);
           \\ mapisdefined(m,subtree_sizes,&c);
           \\ mapput(m,subtree_sizes,c+1);
           \\ count += (subtree_sizes==vecsort(subtree_sizes,,0));
           \\ vpar_is_subtree_sizes_vector(subtree_sizes) || error();
     );
     \\ print(count",");             \\ vpar with increasing sizes
     m=Mat(m);
     print(matsize(m)[1],",");  \\ vectors occurring

     \\ print(m[,2]);  \\ counts
     \\ for(i=1,matsize(m)[1],
     \\    if(m[i,2]>1, print(m[i,1])));
  );
  quit;
}

{
  for(n=4,4,
     my(m=Map());
     forvec(vec=vpar_forvec_from(n,0), \\ forests or trees
           my(vpar=vpar_from_upascend(vec),
              subtree_sizes = vpar_subtree_sizes_vector(vpar),
              l);
           if(!mapisdefined(m,subtree_sizes,&l),l=List([]));
           listput(l,vpar);
           mapput(m,subtree_sizes,l);
     );
     m=Mat(m);
     for(i=1,matsize(m)[1],
        if(#m[i,2]>1, print(m[i,1]" "Vec(m[i,2]))));
     );
  quit;
}


\\------------------------------------------------------------------------------
\\ vpar_subtree_sizes_vector() sum min and max

\\ sums range from 2*n-1 star (unique)
\\            up to path at n*(n+1)/2 triangle, permutations of path

triangular(n) =
{
  n*(n+1)/2 == sum(i=1,n, i) || error;
  n*(n+1)/2;
}
{
  for(n=1,8,
     print("n="n" star ",(n-1)+n," triangular "triangular(n));
     my(m=Map());
     forvec(vec=vpar_forvec_from(n,-1), \\ forests or trees
           my(vpar=vpar_from_upascend(vec),
              subtree_sizes = vpar_subtree_sizes_vector(vpar),
              s = vecsum(subtree_sizes),
              count=0);
           mapisdefined(m,s,&count);
           mapput(m,s,count+1);
     );
     m=Mat(m);

     for(i=1,matsize(m)[1],
        print(m[i,1]" count "m[i,2]));
  );
  quit;
}


\\------------------------------------------------------------------------------

vpar_is_subtree_sizes_vector([1,1,1,3,5])

{
  for(n=0,10,
     print("n="n);
     forvec(vec=vpar_forvec_from(n,0), \\ forests or trees
           my(vpar=vpar_from_upascend(vec),
              subtree_sizes = vpar_subtree_sizes_vector(vpar));
           if(!vpar_is_subtree_sizes_vector(subtree_sizes),
              print("WRONG");
              print("vpar "vpar);
              print("subtree_sizes "subtree_sizes);
              quit;
             ));
  );
  print("ok");
}
quit


\\------------------------------------------------------------------------------
\\ vpar_subtree_sizes_vector() count of non-decreasing

\\ not in OEIS: 1, 1, 2, 5, 16, 58, 246, 1141,

{
  for(n=1,10,
     my(count=0);
     forvec(vec=vpar_forvec_from(n), \\ trees
           my(vpar=vpar_from_upascend(vec));
           my(subtree_sizes =vpar_subtree_sizes_vector(vpar));
           if(test_vector_is_increasing(subtree_sizes),
              count++));
     print(count","););
  quit;
}

\\------------------------------------------------------------------------------
\\ max ancestor is non-decreasing -- count formula
\\ vector(5,n, n^(n-2))

{ my(count=0); forvec(vec=vpar_forvec_from(5),count++); count }
check_exact(625, 5^4);

a(n) =
{
  if(n==0,0, n==1,1,
     n^(n-2) + sum(p=1,n-1, a(p) * p * (n-p)^(n-p-2)));
}

f(n) =
{
  my(debug=0);
  if(debug,print("n="n));
  my(t=0);
  if(n==0,t=0,
     n==1,t=1,

     if(debug,print(" "n"^",n-2," = ",n^(n-2)));  \\ n as root
     t=n^(n-2)
     + sum(p=1,n-1,
             my(o=n-p);  \\ n-1 to 1
             if(debug,print(" p="p" o="o"  "o"^",o-2," * "p" * "f(p)));
             f(p) * p * o^(o-2)));
  if(debug,print(" total "t));
  t;
}
f=memoize(f);
vector(10,n,n--; f(n))
vector(10,n,n--; a(n))
quit

\\ n=3
\\ [0, 1, 1]   vec [1, 2, 3]
\\ [0, 1, 2]   vec [1, 2, 3]
\\ [0, 3, 1]   vec [1, 3, 3]
\\ [2, 0, 1]   vec [2, 2, 3]
\\ [2, 0, 2]   vec [2, 2, 3]
\\ [3, 1, 0]   vec [3, 3, 3]
\\ [2, 3, 0]   vec [3, 3, 3]
\\ [3, 3, 0]   vec [3, 3, 3]
\\ count 8

\\------------------------------------------------------------------------------
