\\ Copyright 2018, 2020 Kevin Ryde
\\
\\ This file is free software; you can redistribute it and/or modify it
\\ under the terms of the GNU General Public License as published by the Free
\\ Software Foundation; either version 3, or (at your option) any later
\\ version.
\\
\\ This file is distributed in the hope that it will be useful, but
\\ WITHOUT ANY WARRANTY; without even the implied warranty of MERCHANTABILITY
\\ or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU General Public License
\\ for more details.
\\
\\ You should have received a copy of the GNU General Public License along
\\ with this file.  See the file COPYING.  If not, see
\\ <http://www.gnu.org/licenses/>.

\\ Usage: gp -f <test-disjoint-domnum-inf.gp

default(recover,0);
default(strictargs,1);

option_verbose=1;

read("../vpar.gp");
read("../vpar-wip.gp");
read("../test-helpers.gp");


\\-----------------------------------------------------------------------------
\\ vpar_disjoint_domnum() and friends

\\ lo=3; hi=5; hi-lo+1 == 3 as range 0 to 2, plus lo is 3 to 3+2=5
test_random_in_range(lo,hi) = random(hi-lo+1)+lo;

{
  for(i=1,10000,
     my(n=test_random_in_range(6,14),
        forest=random(2),
        vpar=vpar_make_random(n,forest));
     \\ print("vpar "vpar" n="n);
     my(
        want_quantities=test_disjoint_domnum_and_count_quantities_by_flags(vpar),
        want_domnum_and_count = want_quantities[6,],
        want_domnum = want_domnum_and_count[1],
        got_quantities =vpar_disjoint_domnum_and_count_quantities(vpar),
        got_domnum_and_count=vpar_disjoint_domnum_and_count(vpar),
        got_domnum=vpar_disjoint_domnum(vpar),
        got_without_dom_dom   = got_quantities[3,1],
        got_without_dom_undom = got_quantities[4,1],
        got_without_dom_dom_count   = got_quantities[3,2],
        got_without_dom_undom_count = got_quantities[4,2],
        got_without_dom_bigger =
          if(got_without_dom_dom_count && got_without_dom_undom_count,
             got_without_dom_dom >= got_without_dom_undom,
             1));

     if(got_quantities != want_quantities
        || got_domnum_and_count != want_domnum_and_count
        || got_domnum != want_domnum
        || !got_without_dom_bigger,
        print("vpar "vpar);
        print("got");
        print(got_quantities);
        print(got_domnum_and_count);
        print(got_domnum);
       );

     check_equal(got_quantities, want_quantities);
     check_equal(got_domnum_and_count, want_domnum_and_count);
     check_equal(got_domnum, want_domnum);
     check_equal(got_without_dom_bigger, 1,
                 "without_dom_dom >= without_dom_undom");
     );
}

\\ vpar [0, 1, 0, 12, 11, 2, 8, 11, 1, 2, 6, 5, 3]
\\ got
\\ [11, 4; -1, 0; -1, 0; -1, 0; -1, 0; 11, 2]
\\ [11, 4]
\\ 11
\\ wrong at 225: 
\\ got  [11, 4; -1, 0; -1, 0; -1, 0; -1, 0; 11, 2]
\\ want [11, 4; -1, 0; -1, 0; -1, 0; -1, 0; 11, 4]


\\ {
\\   my(forest=0);
\\   for(n=0, test_limit_trees_search - forest,
\\      forvec(vec=vpar_forvec_from(n,forest), \\ trees
\\            my(vpar=vpar_from_upascend(vec));
\\            check_equal(test_disjoint_domnum_and_count_by_flags(vpar),
\\                        vpar_disjoint_domnum_and_count(vpar))));
\\ }

